﻿Imports Grasshopper.Kernel
Imports Grasshopper.Kernel.Types
Imports Grasshopper.Kernel.Data
'Imports Rhino.Geometry

Public Class Class1
    Inherits GH_Component

    ''constructor
    Public Sub New()

        MyBase.New("Sap2000 - Testna komponenta", "Sap", "Vhodni podatki v obliki koordinat vozlisc posameznih ploskev v programsu Sap2000 generirajo mrezo koncnih elementov.", "PrimeriKomponent_ZigaSebenik", "Prenos KE")
    End Sub

    Public Overrides ReadOnly Property ComponentGuid As Guid
        Get
            Return New Guid("80016c7b-a160-4423-b445-a9ce00464833")
        End Get
    End Property

    Protected Overrides Sub RegisterInputParams(pManager As Grasshopper.Kernel.GH_Component.GH_InputParamManager)

        pManager.AddGenericParameter("Koordinate vozlisc koncnih elementov", "Koo", "generic_parameter", GH_ParamAccess.tree)
    End Sub

    Protected Overrides Sub RegisterOutputParams(pManager As Grasshopper.Kernel.GH_Component.GH_OutputParamManager)

    End Sub

    Protected Overrides Sub SolveInstance(DA As IGH_DataAccess)
        Dim ret As Long
        Dim list As New GH_Structure(Of IGH_Goo)
        DA.GetDataTree(Of IGH_Goo)(0, list)

        Dim tocka(1) As GH_Point

        Dim SapObject As New SAP2000v15.SapObject
        Dim SapModel As New SAP2000v15.cSapModel

        'Predpostavimo, da je SAP2000 predhodno odprt in je inicializiran nov model. V nasprotnem primeru to naredimo s spodnjimi ukazi.
        'SapObject.ApplicationStart()
        'ret = SapModel.InitializeNewModel()
        'ret = SapModel.File.NewBlank
        ret = SapModel.SetPresentUnits(SAP2000v15.eUnits.kN_m_C)
        ret = SapModel.SelectObj.All(False)
        ret = SapModel.AreaObj.Delete("name", 2)
        ret = SapModel.PointObj.DeleteSpecialPoint("name", 2)

        For i = 0 To list.Count - 1
            tocka(0) = list.ElementAt(i)
            ret = SapModel.PointObj.AddCartesian(tocka(0).Value.X, tocka(0).Value.Y, tocka(0).Value.Z, "Name", CStr(i), , True)
        Next

        ret = SapModel.SelectObj.All(False)
        ret = SapModel.PointObj.SetSpecialPoint("name", True, 2)

        For i = 0 To list.Branches.Count - 1
            Dim countB As Integer = list.Branch(i).Count
            ReDim tocka(countB)
            Dim X(countB - 1) As Double
            Dim Y(countB - 1) As Double
            Dim Z(countB - 1) As Double
            For j = 0 To countB - 1
                tocka(j) = list.Branch(i).Item(j)
                X(j) = tocka(j).Value.X
                Y(j) = tocka(j).Value.Y
                Z(j) = tocka(j).Value.Z
            Next
            ret = SapModel.AreaObj.AddByCoord(countB, X, Y, Z, "Name")
        Next

        ret = ret = SapModel.SelectObj.ClearSelection
        ret = SapModel.View.RefreshView

    End Sub

End Class
